<?php 

class actionMomentsListAjax extends cmsAction {

    public function run(){

        $content_model = cmsCore::getModel('content');
        $content_controller = cmsCore::getController('content');

        $ctype = $content_model->getContentTypeByName('moments');

        if (!$ctype) { cmsCore::error404(); }
        if (!$ctype['options']['list_on']) { cmsCore::error404(); }

        $slug = $this->request->get('slug');
        if (!$ctype['is_cats'] && $slug != 'index') { cmsCore::error404(); }

        $getDate = trim($this->request->get('getDate'), '');
        $start = trim($this->request->get('start'), '');
        $end = trim($this->request->get('end'), '');
        $category_id = $this->request->get('category_id', '');
        $filters = $this->request->get('filters', array());

        $category = array('id' => 1, 'parent_id' => 0);
        $subcats = array();

        $props = $props_fields = false;

        $fields = $content_model->getContentFields($ctype['name']);

        if ($category_id>1){
            $props = $content_model->getContentProps($ctype['name'], $category_id);
            $props_fields = $content_controller->getPropsFields($props);
        }

        if ($ctype['is_cats'] && $slug != 'index') {
            $category = $content_model->getCategory('moments', $category_id);
            if (!$category){ cmsCore::error404(); }
        }

        if ($ctype['is_cats']) {
            $current_cat_id = $category['id'] ? $category['id'] : 1;
            $subcats = $content_model->getSubCategories('moments', $current_cat_id);
        }

        $dataset = $this->request->get('dataset', false);

        $datasets = $content_model->getContentDatasets($ctype['id'], true);

        if ($datasets){
            if($dataset && empty($datasets[$dataset])){ cmsCore::error404(); }
            $keys = array_keys($datasets);
            $current_dataset = $dataset ? $datasets[$dataset] : $datasets[$keys[0]];
            $content_model->applyDatasetFilters($current_dataset);
        }

        if ($ctype['is_cats'] && $slug != 'index') {
            $content_model->filterCategory('moments', $category, $ctype['is_cats_recursive']);
        }

        $events_list_html = '';
        $is_hide_items = !empty($ctype['options']['is_empty_root']) && $slug == 'index';

        if (!$is_hide_items){
            $events_list_html = $this->renderEventsList($ctype, $content_model, $fields, $category['id'], $props, $props_fields, $filters, $start, $end, $getDate);
        }

//		cmsModel::cacheResult('current_ctype', $ctype);
//		cmsModel::cacheResult('current_ctype_category', $category);

        return $this->cms_template->renderJSON($events_list_html, true);
    }
}