<?php
class moments extends cmsFrontend {

    public function routeAction($action_name) {

        $core = cmsCore::getInstance();

        if (!$this->isActionExists($action_name)){
            $core->uri_controller = 'content';
            $core->runController();
            $this->current_params = array();
            return 'exit';
        }

        return $action_name;
    }

    public function actionExit(){ return; }

//============================================================================//
//============================================================================//

    public function getRepeatDates($c_start, $c_now, $c_end, $mc_start, $mc_end = false, $mc_rpt = 'none', $mc_rpt_end_date = false, $mc_rpt_qty = 0){

        if ($mc_rpt == 'none'){return array();}
        $c_start = new DateTime( $c_start );
        $start = $c_start;
        $c_end = new DateTime( $c_end );
        $mc_start = new DateTime( $mc_start );
        $mc_end = $mc_end ? new DateTime( $mc_end ) : $mc_start;

        $mc_diff = $mc_start->diff($mc_end);

        $mc_start_diff = $c_start->diff($mc_start);

        $interval = new DateInterval('P' . $mc_start_diff->y . 'Y' . $mc_start_diff->m . 'M' . $mc_start_diff->d . 'DT' . $mc_start_diff->h . 'H' . $mc_start_diff->i . 'M' . $mc_start_diff->s . 'S');
        if (!$mc_start_diff->invert){
            $c_start->add($interval);
        } else {
            $c_start->sub($interval);
        }

        $dates = array();

        if ($mc_rpt == 'daily'){

            $c_end = $c_end->modify( '+1 day' );

            $interval = new DateInterval('P1D');
            $daterange = new DatePeriod($c_start, $interval, $c_end);

            foreach($daterange as $date){
                $new_date = $date->format("Y-m-d H:i:s");
                if ($mc_rpt_end_date){
                    if ($mc_rpt_end_date && ($new_date > $mc_rpt_end_date)){ break; }
                }

                if ($mc_rpt_qty > 0 && $mc_start->diff($date)->days >= $mc_rpt_qty){ break; }

                $dates[] = array(
                    'start' => $new_date,
                    'end' => $date->add(new DateInterval('P' . $mc_diff->y . 'Y' . $mc_diff->m . 'M' . $mc_diff->d . 'DT' . $mc_diff->h . 'H' . $mc_diff->i . 'M' . $mc_diff->s . 'S'))->format("Y-m-d H:i:s")
                );
            }
        }

        if ($mc_rpt == 'weekly'){

            $c_end = $c_end->modify( '+7 day' );

            $interval = new DateInterval('P7D');
            $daterange = new DatePeriod($c_start, $interval, $c_end);

            foreach($daterange as $date){
                $new_date = $date->format("Y-m-d H:i:s");
                if ($mc_rpt_end_date && $new_date > $mc_rpt_end_date){ break; }

                if ($mc_rpt_qty > 0 && $mc_start->diff($date)->days >= $mc_rpt_qty){ break; }

                $dates[] = array(
                    'start' => $new_date,
                    'end' => $date->add(new DateInterval('P' . $mc_diff->y . 'Y' . $mc_diff->m . 'M' . $mc_diff->d . 'DT' . $mc_diff->h . 'H' . $mc_diff->i . 'M' . $mc_diff->s . 'S'))->format("Y-m-d H:i:s")
                );
            }
        }

        if ($mc_rpt == 'monthlyByDay'){

            $f_day = DateTime::createFromFormat('Y-m-d H:i:s', $mc_start->format('Y') . '-' . $mc_start->format('m') . '-1 00:00:00')->format('w');

            $interval = new DateInterval('P1M');
            $daterange = new DatePeriod($c_start, $interval, $c_end);

            foreach($daterange as $date){
                $c_day = DateTime::createFromFormat('Y-m-d H:i:s', $date->format('Y') . '-' . $date->format('m') . '-1 00:00:00')->format('w');

                $r_days = $f_day - $c_day;

                if ($r_days > 0){
                    $date->modify( '+' . $r_days . ' days');
                } elseif ($r_days < 0){
                    $date->modify( '-' . abs($r_days) . ' days');
                }
                if ($date->format('w') >= $c_day){
                    $date->modify( '-7 days');
                }
                $new_date = $date->format("Y-m-d H:i:s");

                if ($mc_rpt_end_date && $new_date > $mc_rpt_end_date){ break; }

                if ($mc_rpt_qty > 0 && $mc_start->diff($date)->days >= $mc_rpt_qty){ break; }

                $dates[] = array(
                    'start' => $new_date,
                    'end' => $date->add(new DateInterval('P' . $mc_diff->y . 'Y' . $mc_diff->m . 'M' . $mc_diff->d . 'DT' . $mc_diff->h . 'H' . $mc_diff->i . 'M' . $mc_diff->s . 'S'))->format("Y-m-d H:i:s")
                );
            }
        }

        if ($mc_rpt == 'monthlyByDate'){

            $interval = new DateInterval('P1M');
            $daterange = new DatePeriod($c_start, $interval, $c_end);

            foreach($daterange as $date){
                $new_date = $date->format("Y-m-d H:i:s");
                if ($mc_rpt_end_date && $new_date > $mc_rpt_end_date){ break; }

                if ($mc_rpt_qty > 0 && $mc_start->diff($date)->days >= $mc_rpt_qty){ break; }

                $dates[] = array(
                    'start' => $new_date,
                    'end' => $date->add(new DateInterval('P' . $mc_diff->y . 'Y' . $mc_diff->m . 'M' . $mc_diff->d . 'DT' . $mc_diff->h . 'H' . $mc_diff->i . 'M' . $mc_diff->s . 'S'))->format("Y-m-d H:i:s")
                );
            }
        }

        if ($mc_rpt == 'yearly'){

            $interval = new DateInterval('P1Y');
            $daterange = new DatePeriod($c_start, $interval, $c_end);

            foreach($daterange as $date){
                $new_date = $date->format("Y-m-d H:i:s");
                if ($mc_rpt_end_date && $new_date > $mc_rpt_end_date){ break; }

                if ($mc_rpt_qty > 0 && $mc_start->diff($date)->days >= $mc_rpt_qty){ break; }

                $dates[] = array(
                    'start' => $new_date,
                    'end' => $date->add(new DateInterval('P' . $mc_diff->y . 'Y' . $mc_diff->m . 'M' . $mc_diff->d . 'DT' . $mc_diff->h . 'H' . $mc_diff->i . 'M' . $mc_diff->s . 'S'))->format("Y-m-d H:i:s")
                );
            }
        }

        return $dates;

    }

//============================================================================//
//============================================================================//

    public function renderEventsList($ctype, $content_model, $fields, $category_id=1, $props=false, $props_fields=false, $filters = array(), $start=false, $end=false, $getDate=false){

        // проверяем запросы фильтрации по полям
        foreach($fields as $name => $field){

            if (!$field['is_in_filter']) { continue; }
            if (!isset($filters[$name])){ continue; }

            $value = $filters[$name];
            if (is_array($value)){
                if (!$value['from'] && !$value['to']){$value = false;}
            }
            if (!$value) { continue; }

            $content_model = $field['handler']->applyFilter($content_model, $value);
            $filters[$name] = $value;

        }

        // проверяем запросы фильтрации по свойствам
        if (is_array($props)){
            foreach($props as $prop){

                $name = "p{$prop['id']}";

                if (!$prop['is_in_filter']) { continue; }
                if (!$this->request->has($name)){ continue; }

                $value = $this->request->get($name);
                if (!$value) { continue; }

                $content_model->filterPropValue($ctype['name'], $prop, $value);
                $filters[$name] = $value;

            }
        }

        // Сначала проверяем настройки типа контента
        if (!empty($ctype['options']['privacy_type']) && in_array($ctype['options']['privacy_type'], array('show_title', 'show_all'), true)) {
            $content_model->disablePrivacyFilter();
            if($ctype['options']['privacy_type'] != 'show_title'){
                $hide_except_title = false;
            }
        }

        // А потом, если разрешено правами доступа, отключаем фильтр приватности
        if (cmsUser::isAllowed($ctype['name'], 'view_all')) {
            $content_model->disablePrivacyFilter();
            $hide_except_title = false;
        }

        $content_model->filterHiddenParents();

        $content_model->select('m.*');
        $content_model->join('moments', 'm', 'm.item_id = i.id');
        $content_model->filterStart();
        $content_model->filterBetween('m.mc_start', $start, $end);
        $content_model->filterBetween('m.mc_end', $start, $end);
        $content_model->filterOr();
        $content_model->filterNotNull('m.mc_rpt');
        $content_model->filterEnd();

        list($ctype, $content_model) = cmsEventsManager::hook('content_list_filter', array($ctype, $content_model));
        list($ctype, $content_model) = cmsEventsManager::hook("content_{$ctype['name']}_list_filter", array($ctype, $content_model));

        $content_model->useCache("content.list.moments");

        $items = $content_model->getContentItems('moments');

        $events = array();

        cmsModel::cacheResult('current_ctype_fields', $fields);
        cmsModel::cacheResult('current_ctype_props', $props);
        cmsModel::cacheResult('current_ctype_props_fields', $props_fields);

        if (!$items){return $events;}

        foreach($items as $key => $item){

            $is_private = $item['is_private'] && !$item['user']['is_friend'];
            if ($is_private){continue;}

            $url = href_to($ctype['name'], $item['slug'].'.html');
            $item_title = $item['title'];
            $item_allday = $item['mc_allday'] ? $item['mc_allday'] : false;

            if ($item['mc_rpt'] != 'none'){
                $repeat_dates = $this->getRepeatDates($start, $getDate, $end, $item['mc_start'], $item['mc_end'], $item['mc_rpt'], $item['mc_rpt_end_date'], $item['mc_rpt_qty']);

                foreach ($repeat_dates as $rdate){

                    $events[] = array(
                        'id' => $item['id'],
                        'title' => $item_title,
                        'allDay' => $item_allday,
                        'start' => $rdate['start'],
                        'end' =>  $rdate['end'],
                        'overlap' => true,
                        'color' => true,
                        'backgroundColor' => $item['mc_bg_color'],
                        'borderColor' => $item['mc_border_color'],
                        'textColor' => $item['mc_text_color'],
                        'url' => $url
                    );

                }
                continue;
            }

            $events[] = array(
                'id' => $item['id'],
                'title' => $item_title,
                'allDay' => $item_allday,
                'start' => $item['mc_start'],
                'end' => $item['mc_end'],
                'overlap' => true,
                'color' => true,
                'backgroundColor' => $item['mc_bg_color'],
                'borderColor' => $item['mc_border_color'],
                'textColor' => $item['mc_text_color'],
                'url' => $url
            );
        }

        return $events;
    }
}