<?php
	$config = cmsConfig::getInstance();
    
	$this->addCSSFromContext( $this->getTplFilePath('css/jquery-ui.css', false) );
	$this->addCSSFromContext( $this->getTplFilePath('css/jquery-ui-timepicker-addon.min.css', false) );
	$this->addCSSFromContext( $this->getTplFilePath('css/colorpicker.css', false) );
	$this->addCSSFromContext( $this->getTplFilePath('controllers/moments/styles.css', false) );
	$this->addJSFromContext( $this->getJavascriptFileName('jquery-ui') );
	$this->addJSFromContext( $this->getJavascriptFileName('jquery-ui-timepicker-addon.min') );
	$this->addJSFromContext( $this->getJavascriptFileName('jquery-ui-sliderAccess') );
	$this->addJSFromContext( $this->getJavascriptFileName('colorpicker') );
	if ($config->language !== 'en'){ $this->addJSFromContext( $this->getJavascriptFileName('jquery-ui-timepicker-' . $config->language) ); }
    
	$value = is_array($value) ? $value : cmsModel::yamlToArray($value);

	$mc_hash_event = isset($value['mc_hash_event']) ? $value['mc_hash_event'] : uniqid();
	$mc_start = isset($value['mc_start']) ? $value['mc_start'] : false;
	$mc_end = isset($value['mc_end']) ? $value['mc_end'] : false;
	$mc_allday = isset($value['mc_allday']) ? $value['mc_allday'] : false;
	$mc_rpt = isset($value['mc_rpt']) ? $value['mc_rpt'] : false;
	$mc_rpt_end_use = isset($value['mc_rpt_end_use']) ? $value['mc_rpt_end_use'] : 'always';
	$mc_rpt_end_date = isset($value['mc_rpt_end_date']) ? $value['mc_rpt_end_date'] : false;
	$mc_rpt_qty = isset($value['mc_rpt_qty']) ? $value['mc_rpt_qty'] : false;
	$mc_bg_color = isset($value['mc_bg_color']) ? $value['mc_bg_color'] : false;
	$mc_border_color = isset($value['mc_border_color']) ? $value['mc_border_color'] : false;
	$mc_text_color = isset($value['mc_text_color']) ? $value['mc_text_color'] : false;
	$mc_parent_id = isset($value['mc_parent_id']) ? $value['mc_parent_id'] : 0;
?>

<div class="field_moments">
	<?php if ($field->title) { ?><label for="<?php echo $field->id; ?>"><?php echo $field->title; ?></label><?php } ?>

	<?php echo html_input('hidden', $field->element_name . '[mc_hash_event]', $mc_hash_event); ?>

	<div class="moments_dates">
		<label><?php echo LANG_PARSER_MOMENTS_START;?>:&nbsp;
		<?php echo html_input('text', $field->element_name . '[mc_start]', $mc_start, array('id' => $field->id . '_start', 'class' => 'datetime_input')); ?></label>

		<label><?php echo LANG_PARSER_MOMENTS_END;?>:&nbsp;
		<?php echo html_input('text', $field->element_name . '[mc_end]', $mc_end, array('id' => $field->id . '_end', 'class' => 'datetime_input')); ?></label>
	</div>
	<label><?php echo html_checkbox($field->element_name . '[mc_allday]', $mc_allday == 1 ? true : false, 1, array('id' => $field->id . '_allday'))?><?php echo LANG_PARSER_MOMENTS_ALLDAY;?></label>

	<label><?php echo LANG_PARSER_MOMENTS_REPEAT;?><?php echo html_select(
			$field->element_name . '[mc_rpt]', array(
				'none' => LANG_PARSER_MOMENTS_REPEAT_NONE,
				'daily' => LANG_PARSER_MOMENTS_REPEAT_DAILY,
				'weekly' => LANG_PARSER_MOMENTS_REPEAT_WEEKLY,
				'monthlyByDay' => LANG_PARSER_MOMENTS_REPEAT_MONTHLYBYDAY,
				'monthlyByDate' => LANG_PARSER_MOMENTS_REPEAT_MONTHLYBYDATE,
				'yearly' => LANG_PARSER_MOMENTS_REPEAT_YEARLY
			), $mc_rpt, array('id' => $field->id . '_rpt'))?></label>

	<label><?php echo LANG_PARSER_MOMENTS_REPEAT_PERIOD;?><?php echo html_select(
			$field->element_name . '[mc_rpt_end_use]', array(
				'always' => LANG_PARSER_MOMENTS_REPEAT_ALWAYS,
				'use_end_date' => LANG_PARSER_MOMENTS_REPEAT_USE_END_DATE,
				'use_qty' => LANG_PARSER_MOMENTS_REPEAT_QTY
			), $mc_rpt_end_use, array('id' => $field->id . '_rpt_end_use'))?></label>

	<div class="moments_ends">
		<label><?php echo html_input('text', $field->element_name . '[mc_rpt_end_date]', $mc_rpt_end_date, array('id' => $field->id . '_rpt_end_date', 'class' => 'datetime_input')); ?></label>
		<label><?php echo html_input('text', $field->element_name . '[mc_rpt_qty]', $mc_rpt_qty, array('id' => $field->id . '_rpt_qty', 'class' => 'input-number')); ?></label>
	</div>

	<div class="moments_colors">
		<label><?php echo LANG_MOMENTS_EVENT_COLOR_BACKGROUND;?>:&nbsp;<?php echo html_input('text', $field->element_name . '[mc_bg_color]', $mc_bg_color ? $mc_bg_color : $field->options['color_background'], array('id' => $field->id . '_bg_color')); ?></label>

		<label><?php echo LANG_MOMENTS_EVENT_COLOR_BORDER;?>:&nbsp;<?php echo html_input('text', $field->element_name . '[mc_border_color]', $mc_border_color ? $mc_border_color : $field->options['color_border'], array('id' => $field->id . '_border_color')); ?></label>

		<label><?php echo LANG_MOMENTS_EVENT_COLOR_TEXT;?>:&nbsp;<?php echo html_input('text', $field->element_name . '[mc_text_color]', $mc_text_color ? $mc_text_color : $field->options['color_text'], array('id' => $field->id . '_text_color')); ?></label>
	</div>
	<label><?php echo LANG_MOMENTS_EVENT_PARENT_ID;?><?php echo html_select($field->element_name."[mc_parent_id]", $field->getItems(), $mc_parent_id, array('id' => $field->id . '_parent_id')); ?></label>
</div>
<script type="text/javascript">

	function changeItemsList(cat_id){

		var child_list = $('#<?php echo $field->id; ?>_parent_id');

		if ($('.loading-icon').length === 0){ child_list.after('<div class="loading-icon"></div>'); }

		child_list.html('');

		$.post('/moments/get_items_ajax', {cat_id: cat_id, item_id: <?php echo isset($field->item['id']) ? $field->item['id'] : 'false'; ?>}, function(result){

			for(var k in result){ child_list.append('<option value="'+k+'">'+result[k]+'</option>'); }

			$('.loading-icon').remove();

		}, 'json');
	}

	$(document).ready(function(){

		var startBox = $('#<?php echo $field->id; ?>_start');
		var endBox = $('#<?php echo $field->id; ?>_end');
		var allDay = $('#<?php echo $field->id; ?>_allday');
		var repeat_end_date = $('#<?php echo $field->id; ?>_rpt_end_date');

		var sel_rpts = $('#<?php echo $field->id; ?>_rpt');
		var sel_ends = $('#<?php echo $field->id; ?>_rpt_end_use');
		var div_ends = $('.moments_ends');
		var input_end_date = $('#<?php echo $field->id; ?>_rpt_end_date');
		var input_end_qty = $('#<?php echo $field->id; ?>_rpt_qty');

		if (allDay.is(':checked')){
			if (endBox.is(':visible')) {
				endBox.parent().hide();
				endBox.val('');
				startBox.val( startBox.val().slice(0,11) );
			} else {
				endBox.parent().show();
			}
		}

		if (sel_rpts.val() === 'none'){sel_ends.parent().hide();} else {sel_ends.parent().show();}
		if (sel_ends.val() === 'always'){
			div_ends.hide();
			input_end_date.val('');
			input_end_qty.val('');
		} else {div_ends.show();}

		if (sel_ends.val() === 'use_end_date'){input_end_date.parent().show();input_end_qty.val('');} else {input_end_date.parent().hide();input_end_date.val('');}
		if (sel_ends.val() === 'use_qty'){input_end_qty.parent().show();input_end_date.val('');} else {input_end_qty.parent().hide();input_end_qty.val('');}

		$(function() {
			startBox.datepicker({
				onClose: function( selectedDate ) {
					endBox.datepicker( "option", "minDate", selectedDate );
				}
			});
			endBox.datepicker({
				onClose: function( selectedDate ) {
					startBox.datepicker( "option", "maxDate", selectedDate );
				}
			});
			allDay.on({
				change: function() {
					if (endBox.is(':visible')) {
						endBox.parent().hide();
						endBox.val('');
						startBox.val( startBox.val().slice(0,11) );
					} else {
						endBox.parent().show();
					}
				}
			});
			sel_rpts.on({
				change: function() {
					if (sel_rpts.val() === 'none'){sel_ends.parent().hide();} else {sel_ends.parent().show();}
				}
			});
			sel_ends.on({
				change: function() {
					if (sel_ends.val() === 'always'){
						div_ends.hide();
						input_end_date.val('');
						input_end_qty.val('');
					} else {div_ends.show();}
						if (sel_ends.val() === 'use_end_date'){input_end_date.parent().show();input_end_qty.val('');} else {input_end_date.parent().hide();input_end_date.val('');}
						if (sel_ends.val() === 'use_qty'){input_end_qty.parent().show();input_end_date.val('');} else {input_end_qty.parent().hide();input_end_qty.val('');}
				}
			});
		});

		repeat_end_date.datetimepicker(
			{
				addSliderAccess: true,
				sliderAccessArgs: {
					touchonly: false
				},
				showOtherMonths: true,
				selectOtherMonths: true,
				changeYear: true,
				changeMonth: true,
				showOn: "both",
				timeFormat: 'HH:mm',
				dateFormat:'yy-mm-dd'
			}
		);

		$.timepicker.datetimeRange(
			startBox,
			endBox,
			{
				addSliderAccess: true,
				sliderAccessArgs: {
					touchonly: false
				},
				showOtherMonths: true,
				selectOtherMonths: true,
				changeYear: true,
				changeMonth: true,
				firstDay: 1,
				showOn: "both",
				minDate: "1970-01-02",
				timeFormat: 'HH:mm',
				dateFormat:'yy-mm-dd'
			}
		);

		var sel_category_id = $('#category_id');
		sel_category_id.on('change', function(){ changeItemsList($(this).val()); });
	});

	$('input#<?php echo $field->id; ?>_bg_color, input#<?php echo $field->id; ?>_border_color, input#<?php echo $field->id; ?>_text_color').minicolors();
</script>