<?php
$user = cmsUser::getInstance();

$mc_parent_fields = $fields;
$mc_chaild_fields = $fields;
$mc_parent = isset($item['mc_parent']) ? $item['mc_parent'] : array();
$mc_chaild = isset($item['mc_chaild']) ? $item['mc_chaild'] : array();
if ($mc_parent){
    $item['parent_id'] = $mc_parent['id'];
    $item['parent_title'] = $mc_parent['title'];
    $item['parent_url'] = 'moments/' . $mc_parent['slug'] . '.html';
}
?>

<?php if ($fields['title']['is_in_item']){ ?>
    <h1>
        <?php if ($item['parent_id']){ ?>
            <div class="parent_title">

                <a href="<?php echo href_to($item['parent_url']); ?>"><time><?php echo $mc_parent['mc_start'];?></time> - <?php html($item['parent_title']); ?></a> &rarr;
            </div>
        <?php } ?>
        <?php html($item['title']); ?>
        <?php if ($item['is_private']) { ?>
            <span class="is_private" title="<?php html(LANG_PRIVACY_PRIVATE); ?>"></span>
        <?php } ?>
    </h1>
    <?php unset($fields['title']); ?>
<?php } ?>

<?php if ($this->hasMenu('item-menu')){ ?>
    <div id="content_item_tabs">
        <div class="tabs-menu">
            <?php $this->menu('item-menu', true, 'tabbed'); ?>
        </div>
    </div>
<?php } ?>

<div class="content_item <?php echo $ctype['name']; ?>_item">

    <?php if (!empty($fields)) { ?>

        <?php $fields_fieldsets = cmsForm::mapFieldsToFieldsets($fields, function($field, $user) use ($item) {
            if (!$field['is_in_item'] || $field['is_system']) { return false; }
            if ((empty($item[$field['name']]) || empty($field['html'])) && $item[$field['name']] !== '0') { return false; }
            if ($field['groups_read'] && !$user->isInGroups($field['groups_read'])) { return false; }
            return true;
        } ); ?>

        <?php foreach ($fields_fieldsets as $fieldset) { ?>

            <?php $is_fields_group = !empty($ctype['options']['is_show_fields_group']) && $fieldset['title']; ?>

            <?php if ($is_fields_group) { ?>
                <div class="fields_group">
                    <h3 class="group_title"><?php html($fieldset['title']); ?></h3>
            <?php } ?>

            <?php if (!empty($fieldset['fields'])) { ?>
                <?php foreach ($fieldset['fields'] as $name => $field) { ?>

                    <div class="field ft_<?php echo $field['type']; ?> f_<?php echo $field['name']; ?> <?php echo $field['options']['wrap_type']; ?>_field" <?php if($field['options']['wrap_width']){ ?> style="width: <?php echo $field['options']['wrap_width']; ?>;"<?php } ?>>
                        <?php if ($field['options']['label_in_item'] != 'none') { ?>
                            <div class="title_<?php echo $field['options']['label_in_item']; ?>"><?php html($field['title']); ?>: </div>
                        <?php } ?>
                        <div class="value"><?php echo $field['html']; ?></div>
                    </div>

                <?php } ?>
            <?php } ?>

            <?php if ($is_fields_group) { ?></div><?php } ?>

        <?php } ?>

    <?php } ?>

    <?php if ($props && array_filter((array)$props_values)) { ?>
        <?php
            $props_fields = $this->controller->getPropsFields($props);
            $props_fieldsets = cmsForm::mapFieldsToFieldsets($props);
        ?>
        <div class="content_item_props <?php echo $ctype['name']; ?>_item_props">
            <table>
                <tbody>
                    <?php foreach($props_fieldsets as $fieldset){ ?>
                        <?php if ($fieldset['title']){ ?>
                            <tr>
                                <td class="heading" colspan="2"><?php html($fieldset['title']); ?></td>
                            </tr>
                        <?php } ?>
                        <?php if ($fieldset['fields']){ ?>
                            <?php foreach($fieldset['fields'] as $prop){ ?>
                                <?php if (isset($props_values[$prop['id']])) { ?>
                                <?php $prop_field = $props_fields[$prop['id']]; ?>
                                    <tr>
                                        <td class="title"><?php html($prop['title']); ?></td>
                                        <td class="value">
                                            <?php echo $prop_field->setItem($item)->parse($props_values[$prop['id']]); ?>
                                        </td>
                                    </tr>
                                <?php } ?>
                            <?php } ?>
                        <?php } ?>
                    <?php } ?>
                </tbody>
            </table>
        </div>
    <?php } ?>

    <?php
        $hooks_html = cmsEventsManager::hookAll("content_{$ctype['name']}_item_html", $item);
        if ($hooks_html) { echo html_each($hooks_html); }
    ?>

    <?php
        $is_tags = $ctype['is_tags'] &&
                   !empty($ctype['options']['is_tags_in_item']) &&
                   $item['tags'];
    ?>

    <?php if ($is_tags){ ?>
        <div class="tags_bar">
            <?php echo html_tags_bar($item['tags']); ?>
        </div>
    <?php } ?>

    <?php
        $show_bar = !empty($item['rating_widget']) ||
                    $fields['date_pub']['is_in_item'] ||
                    $fields['user']['is_in_item'] ||
                    !empty($ctype['options']['hits_on']) ||
                    !$item['is_pub'] ||
                    !$item['is_approved'];
    ?>

    <?php if ($ctype['item_append_html']){ ?>
        <div class="append_html"><?php echo $ctype['item_append_html']; ?></div>
    <?php } ?>

    <?php if ($show_bar){ ?>
        <div class="info_bar">
            <?php if (!empty($item['rating_widget'])){ ?>
                <div class="bar_item bi_rating">
                    <?php echo $item['rating_widget']; ?>
                </div>
            <?php } ?>
            <?php if ($fields['date_pub']['is_in_item']){ ?>
                <div class="bar_item bi_date_pub" title="<?php html( $fields['date_pub']['title'] ); ?>">
                    <?php echo $fields['date_pub']['html']; ?>
                </div>
            <?php } ?>
            <?php if (!$item['is_pub']){ ?>
                <div class="bar_item bi_not_pub">
                    <?php echo LANG_CONTENT_NOT_IS_PUB; ?>
                </div>
            <?php } ?>
            <?php if (!empty($ctype['options']['hits_on'])){ ?>
                <div class="bar_item bi_hits" title="<?php echo LANG_HITS; ?>">
                    <?php echo $item['hits_count']; ?>
                </div>
            <?php } ?>
            <?php if ($fields['user']['is_in_item']){ ?>
                <div class="bar_item bi_user" title="<?php html( $fields['user']['title'] ); ?>">
                    <?php echo $fields['user']['html']; ?>
                </div>
                <?php if (!empty($item['folder_title'])){ ?>
                    <div class="bar_item bi_folder">
                        <a href="<?php echo href_to('users', $item['user']['id'], array('content', $ctype['name'], $item['folder_id'])); ?>"><?php echo $item['folder_title']; ?></a>
                    </div>
                <?php } ?>
            <?php } ?>
            <div class="bar_item bi_share">
                <div class="share">
                    <script type="text/javascript" src="//yastatic.net/es5-shims/0.0.2/es5-shims.min.js" charset="utf-8"></script>
<script type="text/javascript" src="//yastatic.net/share2/share.js" charset="utf-8"></script>
<div class="ya-share2" data-services="vkontakte,facebook,odnoklassniki,moimir,gplus,twitter,viber,whatsapp" data-size="s"></div>
                </div>
            </div>
            <?php if (!$item['is_approved']){ ?>
                <div class="bar_item bi_not_approved">
                    <?php echo LANG_CONTENT_NOT_APPROVED; ?>
                </div>
            <?php } ?>
        </div>
    <?php } ?>

</div>

<?php if ($mc_chaild){ ?>

    <div class="content_list featured <?php echo $ctype['name']; ?>_list">

        <?php foreach($mc_chaild as $chaild){ ?>

            <?php
                $chaild['ctype'] = $ctype;
                $is_private    = $chaild['is_private'] && $hide_except_title && !$chaild['user']['is_friend'];
                $stop          = 0;
            ?>

            <div class="content_list_item <?php echo $ctype['name']; ?>_list_item<?php if (!empty($chaild['is_vip'])){ ?> is_vip<?php } ?>">

                <?php if (isset($mc_chaild_fields['photo']) && $mc_chaild_fields['photo']['is_in_list'] && !empty($chaild['photo'])){ ?>
                    <div class="photo">
                        <?php if ($is_private) { ?>
                            <?php echo html_image(default_images('private', $mc_chaild_fields['photo']['options']['size_teaser']), $mc_chaild_fields['photo']['options']['size_teaser'], $chaild['title']); ?>
                        <?php } else { ?>
                            <a href="<?php echo href_to($ctype['name'], $chaild['slug'].'.html'); ?>">
                                <?php echo html_image($chaild['photo'], $mc_chaild_fields['photo']['options']['size_teaser'], $chaild['title']); ?>
                            </a>
                        <?php } ?>
                        <?php unset($chaild['photo']); ?>
                    </div>
                <?php } ?>

                <div class="fields">

                    <div class="date_start"><?php echo $chaild['mc_start'];?></div>

                    <?php
                        if (!isset($mc_chaild_fields['title']['options']['label_in_list'])) {
                            $label_pos = 'none';
                        } else {
                            $label_pos = $mc_chaild_fields['title']['options']['label_in_list'];
                        }
                    ?>

                    <div class="field ft_caption f_title">

                        <?php if ($label_pos != 'none'){ ?>
                            <div class="title_<?php echo $label_pos; ?>"><?php echo $mc_chaild_fields['title']['title'] . ($label_pos=='left' ? ': ' : ''); ?></div>
                        <?php } ?>

                        <div class="value">
                            <?php if ($mc_chaild_fields['title']['name'] == 'title' && $ctype['options']['item_on']){ ?>
                                <?php if ($is_private) { ?>
                                    <?php html($chaild['title']); ?> <span class="is_private" title="<?php html(LANG_PRIVACY_PRIVATE); ?>"></span>
                                <?php } else { ?>
                                    <a href="<?php echo href_to($ctype['name'], $chaild['slug'].'.html'); ?>"><?php html($chaild['title']); ?></a>
                                    <?php if ($chaild['is_private']) { ?>
                                        <span class="is_private" title="<?php html(LANG_PRIVACY_PRIVATE); ?>"></span>
                                    <?php } ?>
                                <?php } ?>

                            <?php } else { ?>

                               <?php if ($is_private) { $stop++; ?>
                                    <!--noindex--><div class="private_field_hint"><?php echo LANG_PRIVACY_PRIVATE_HINT; ?></div><!--/noindex-->
                               <?php } ?>
                            <?php } ?>
                        </div>

                    </div>

                    <div class="field ft_html f_content">

                        <?php if ($label_pos != 'none'){ ?>
                            <div class="title_<?php echo $label_pos; ?>"><?php echo $mc_chaild_field['title'] . ($label_pos=='left' ? ': ' : ''); ?></div>
                        <?php } ?>

                        <div class="value">
                            <?php echo string_short($mc_chaild_fields['content']['handler']->setItem($chaild)->parseTeaser($chaild['content']), 100); ?>
                        </div>

                    </div>

                </div>

                <?php
                    $is_tags = $ctype['is_tags'] &&
                            !empty($ctype['options']['is_tags_in_list']) &&
                            $chaild['tags'];
                ?>

                <?php if ($is_tags){ ?>
                    <div class="tags_bar">
                        <?php echo html_tags_bar($chaild['tags']); ?>
                    </div>
                <?php } ?>
            </div>

        <?php } ?>

    </div>
<?php }