<?php
    $this->addCSSFromContext( $this->getTplFilePath('js/fullcalendar/fullcalendar.min.css', false) );
    $this->addCSSFromContext( $this->getTplFilePath('controllers/moments/styles.css', false) );
    $this->addJSFromContext( $this->getJavascriptFileName('fullcalendar/moment.min') );
    $this->addJSFromContext( $this->getJavascriptFileName('fullcalendar/fullcalendar.min') );
    $this->addJSFromContext( $this->getJavascriptFileName('fullcalendar/lang-all') );

    if( $ctype['options']['list_show_filter'] ) {
        $this->renderAsset('ui/filter-panel', array(
            'css_prefix'   => $ctype['name'],
            'page_url'     => $page_url,
            'fields'       => $fields,
            'props_fields' => $props_fields,
            'props'        => $props,
            'filters'      => $filters,
            'ext_hidden_params' => $ext_hidden_params,
            'is_expanded'  => $ctype['options']['list_expand_filter']
        ));
    }
?>

<div id="script-warning"><?php echo LANG_PARSER_MOMENTS_NO_DATA;?></div>
<div id="loading"><?php echo LANG_LOADING;?></div>
<div id="calendar"></div>

<script>
$(document).ready(function() {

    $('#calendar').fullCalendar({
        header: {
            left: "prev,next today,agendaFourDay",
            center: "title",
            right: "Year,month,agendaWeek,agendaDay"
        },
        firstDay: 1,
        height: 'auto',
        contentHeight: 'auto',
        eventLimit: true,
        views: {
            month: {
                titleFormat: 'MMMM YYYY',
                columnFormat: 'dddd',
                eventLimit: 4
            },
            week: {
                titleFormat: "DD.MM.YYYY",
                columnFormat: 'dd DD',
                eventLimit: 4
            },
            day: {
                columnFormat: 'dddd',
                eventLimit: 4
            },
            agendaFourDay: {
                columnFormat: 'dd DD',
                titleFormat: "DD.MM.YYYY",
                type: 'agenda',
                duration: { days: 4 },
                buttonText: '4 day',
                eventLimit: 4
            }
        },
        defaultView: 'month',
        slotLabelFormat: 'H:mm',
        timeFormat: 'H(:mm)',
        lang: '<?php echo cmsConfig::get('language');?>',
        displayEventTime: true,
        displayEventEnd: true,
        dayPopoverFormat: 'dddd, MMMM D',
        eventMouseover: function(  ) {
            $(this).css('opacity', '0.5');
        },
        eventMouseout: function(  ) {
            $(this).css('opacity', '1');
        },
        eventOrder: 'start',
        eventSources: [{
            events: function(start, end, timezone, callback) {
                $.ajax({
                    url: '/moments/list_ajax',
                    dataType: 'json',
                    method: "POST",
                    data: {
                        getDate: $('#calendar').fullCalendar('getDate').format('YYYY-MM-DD HH:mm:ss'),
                        start: $.fullCalendar.moment(start).format('YYYY-MM-DD HH:mm:ss'),
                        end: $.fullCalendar.moment(end).format('YYYY-MM-DD HH:mm:ss'),
                        category_id: <?php echo $category_id ? $category_id : 1;?>,
                        slug: '<?php echo cmsCore::getInstance()->request->get('slug');?>',
                        filters: <?php echo isset($filters) ? json_encode($filters) : '[]';?>
                    },
                    success: function(items) { callback(items); },
                    error: function() { $('#script-warning').show(); }
                });
            },
            color: 'black',
            textColor: 'yellow'
        }]
    });
});
</script>
<div id="add_moment_form" class="ajax-modal" style="display: none;"></div>